
#include <math.h>
#include "cgm.h"
#include "cgm_soft.h"

#define STEPS 28
#define MOVES (sizeof(mvment))
#define LENGTH 25
#define WURMS 16

extern char piece1[],piece2[];

static CGM *pala1,*pala2;
static int skale,px,py,
           a11,a12,
           a21,a22;

static double qd[8][STEPS][2];
static char mvment[]={0,1, 4,5,6,7, 4,1, 2,3,6,7, 4,1,2,3,6,3,0,5};
static int cord[MOVES*STEPS][2],lx[WURMS],ly[WURMS];

static void transu(int x,int y,int *xx,int *yy)
{
    int tmp=x;
    x = (x*a11 + y*a12)>>12;
    y = (tmp*a21 + y*a22)>>12;
    *xx= (x*skale>>14)+320*2+px;
    *yy=-(y*skale>>14)+200*2+py;
}

void wurms_init(void)
{
    int n,i,j;
    double d,dx,dy,ox,oy,ny,nx;

    /*pala1=cgm_load("data/palanen.cgm");
    pala2=cgm_load("data/palanen2.cgm");*/

    pala1=cgm_get(piece1);
    pala2=cgm_get(piece2);

    for(n=0;n<4;n++)
    {
        ox=cos(M_PI*2.0*n/4);
        oy=sin(M_PI*2.0*n/4);
        for(i=d=0;i<STEPS;i++)
        {
            nx=cos(M_PI*2.0*n/4+d);
            ny=sin(M_PI*2.0*n/4+d);
            dx=nx-ox; dy=ny-oy;
            ox=nx; oy=ny;
            qd[n][i][0]=dx;
            qd[n][i][1]=dy;
            d+=M_PI/2.0/STEPS;
        }
    }
    for(n=0;n<4;n++)
    {
        ox=cos(-M_PI*2.0*n/4);
        oy=sin(-M_PI*2.0*n/4);
        for(i=d=0;i<STEPS;i++)
        {
            nx=cos(-M_PI*2.0*n/4-d);
            ny=sin(-M_PI*2.0*n/4-d);
            dx=nx-ox; dy=ny-oy;
            ox=nx; oy=ny;
            qd[n+4][i][0]=dx;
            qd[n+4][i][1]=dy;
            d+=M_PI/2.0/STEPS;
        }
    }

    nx=ny=0;
    for(n=0;n<MOVES*STEPS;n++)
    {
        i=n/STEPS;
        j=n%STEPS;
        cord[n][0]=nx*25*4;
        cord[n][1]=ny*25*4;
        nx+=qd[mvment[i]][j][0];
        ny+=qd[mvment[i]][j][1];
    }

    for(n=0;n<WURMS;n++)
    {
        lx[n]=(n*540+rand()%200)%800-300;
        ly[n]=(n*150+rand()%200)%800-300;
    }
}

void wurms(unsigned char *buf,int tid,int num)
{
    int n,i,off,j,k,x,y,xp,yp;

    for(n=0;n<num;n++)
    {
        off=STEPS*MOVES/WURMS*n+tid/(20+n/5);
        xp=lx[n];
        yp=ly[n];

        a11=1<<12; a12=0;
        a21=0; a22=1<<12;

        for(i=0;i<LENGTH;i++)
        {
            off=(off+4)%(STEPS*MOVES);

            px=xp+cord[off][0];
            py=yp+cord[off][1];
            
            skale=4+i/6;
            if(i==LENGTH-1)
                skale=4;
            cgm_render(pala1,buf,transu);
        }
    }
}

void wurms2(unsigned char *buf,int tid,int num)
{
    int n,i,off,j,k,x,y,xp,yp,lof,nx,ny;

    for(n=0;n<num;n++)
    {
        off=(STEPS*MOVES/WURMS*n+tid/(20+n/5))%(STEPS*MOVES);
        xp=lx[n];
        yp=ly[n];

        for(i=0;i<LENGTH;i++)
        {
            lof=off;
            off=(off+5)%(STEPS*MOVES);
            px=xp+cord[off][0];
            py=yp+cord[off][1];

            nx=cord[off][0]-cord[lof][0];
            ny=cord[off][1]-cord[lof][1];

            a11=nx*160; a12=ny*160;
            a21=-ny*160; a22=nx*160;

            skale=11;
            cgm_render(pala2,buf,transu);
        }
    }
}
